/** Klasse, die eine Lokomotive beschreibt. Jede Lok hat eine Laenge, eine 
 * Nummer zur Identifizierung und merkt sich den ersten Wagen.
 *
 * @author Kirsten
 * @version 1.0
 */

//Diese Klasse ist nicht final und kann zur Vererbung verwendet werden,
//z.B. um Diesellok als Unterklasse zu definieren.

//Die Klasse gehrt zum package zuege und bentigt das package waggons
package zuege;
import zuege.waggons.*;

public class Lokomotive
{
    //Lnge der Lokomotive
    private float laenge;
    //eindeutige Nummer der Lokomotive
    private int nummer;
    //Name der Lokomotive
    private String name;
    
    //der erste Waggon
    private Waggon anfang;

    /** Konstruktor, erzeugt neue Lokomotive aus Lnge und Nummer
     * @param l Lnge der Lokomotive
     * @param nr Nummer der Lokomotive
     */
    public Lokomotive(float l, int nr)
    {
	laenge = l;
	nummer = nr;
	name = new String();

	anfang = null;
    }

    /** Konstruktor, erzeugt neue Lokomotive aus Name, Lnge und Nummer
     * @param name Name der Lokomotive
     * @param l Lnge der Lokomotive
     * @param nr Nummer der Lokomotive
     */
    public Lokomotive(String name, float l, int nr)
    {
	laenge = l;
	nummer = nr;
	this.name = new String(name);

	anfang = null;
    }

    /** Methode, um den ersten Waggon "anzuhngen"
     * @param w Anzuhngender Waggon
     */
    public void setAnfang(Waggon w)
    {
	//Anfang setzen
	//wird hier null gesetzt, hngt kein Waggon an der Lokomotive
	anfang = w;
    }

    /** Methode, die den ersten Waggon zurckliefert
     * @return erster Waggon
     */
    public Waggon getAnfang()
    {
	return anfang;
    }
    
    /** Methode, die die Lnge der Lokomotive zurckliefert
     * @return Lnge
     */
    public float getLaenge()
    {
	return laenge;
    }

    /** Methode, die den Namen der Lokomotive zurckliefert
     * @return Name der Lokomotive
     */
    public String getName()
    {
	return new String(name);
    }

    /** Methode zur Ausgabe der Lokomotive als Zeichenkette
     * @return Zeichenkette, die den Namen (sofern vorhanden), die Nummer und 
     * die Lnge der Lokomotive enthlt
     */

    public String toString()
    {
	String ergebnis = "";
	
	ergebnis += "Lok ";
	
	if(name != null)
	    ergebnis += name + " ";

	ergebnis += "mit Nr. " + nummer + " der Laenge " + laenge; 

	return ergebnis;
    }
}
