/** Klasse, die einen Personenwaggon reprsentiert. Jeder Waggon hat eine
 * festgelegte Anzahl von Sitzpltzen.
 *
 * @author Kirsten
 * @version 1.0
 */

//Diese Klasse gehrt zum package waggons

package zuege.waggons;

//Diese Klasse ist nicht final. Das ist durchaus sinnvoll, denn man knnte
//sich ja weitere Unterklassen wie Doppelstockwaggons vorstellen.

public class Personenwaggon extends Waggon
{
    //Anzahl der Sitzplaetze im Waggon
    private int sitzplaetze;

    /** Konstruktor fr einen Personenwagen.
     * @param plaetze Anzahl der Sitze
     * @param laenge Laenge des Waggons
     */
    public Personenwaggon(int plaetze, float laenge)
    {
	//Zunchst muss der Konstruktor der Oberklasse aufgerufen werden,
	//um die Laenge zu initialisieren
	super(laenge);
	
	//dann werden die Sitzpltze initialisiert
	sitzplaetze = plaetze;
    }

    /** Methode, die die Anzahl der Sitzpltze zurckliefert
     * @return Anzahl der Sitzpltze im Waggon
     */
    public int getPlaetze()
    {
	return sitzplaetze;
    }

    /** Methode zur Ausgabe eines Waggons als String
     * @return Zeichenkette, die den Typ des Waggons, die Anzahl der
     * Sitzpltze sowie die Lnge des Waggons enthlt
     */
    public String toString()
    {
	String ergebnis = "Personenwagen mit " + sitzplaetze + 
	    " Plaetzen der Laenge " + laenge;
	
	return ergebnis;
    }
}
