/** Klasse, die den Waggon eines Zugs reprsentiert. 
 * Jeder Waggon hat eine Lnge und merkt sich den letzten Waggon.
 *
 * @author Kirsten
 * @version 1.0
 */

//Diese Klasse gehrt zum package waggons

package zuege.waggons;

//Diese Klasse ist abstrakt, d.h. es knnen keine Instanzen von ihr gebildet
//werden. Zunchst muss sie als Oberklasse fr Vererbung verwendet werden.
//Die Objekte der vererbten Klassen haben dann u.a. den Typ Waggon!
//Genau wie Interfaces knnen in abstrakten Klassen abstrakte Methoden
//deklariert werden, die die erbende Klasse dann implementieren muss.
//Im Gegensatz zu Interfaces knnen aber auch konkrete Methoden und Attribute
//definiert werden. Auerdem knnen smtliche Zugriffsrechte verwendet werden,
//in Interfaces ist alles per Definition public.

abstract public class Waggon
{
    //Diese Variablen sind protected, damit die erbenden Klassen darauf
    //zugreifen knnen:

    //Lnge des Waggons
    protected float laenge;
    //nchster Waggon
    protected Waggon naechster;

    //obwohl diese Klasse abstrakt ist und keine eigenen Instanzen bilden
    //kann, ist ein Konstruktor sinnvoll
    //dieser initialisiert die Variablen der abstrakten Klasse mit vernnftigen
    //Werten

    /** Konstruktor, bekommt Lnge bergeben
     * zunaechst haengt kein weiterer Waggon an diesem
     * @param laenge Laenge des Waggons
     */
    public Waggon(float laenge)
    {
	this.laenge = laenge;

	this.naechster = null;
    }

    //Die folgenden Methoden sind final, dass bedeutet, sie knnen nicht
    //mehr berschrieben werden:

    /** Methode, um einen Waggon anzuhngen, bzw. abzuhngen 
     * @param w Waggon, der angehngt werden soll, beim Abhngen null
     */
    final public void setNaechster(Waggon w)
    {
	naechster = w;
    }

    /** Methode, um den nchsten Waggon zurckzuliefern
     * @return der nchste Waggon
     */
    final public Waggon getNaechster()
    {
	return naechster;
    }

    /** Methode, um die Laenge zurckzugeben
     * @return Laenge
     */
    final public float getLaenge()
    {
	return laenge;
    } 
}
